#include <lv2plugin.hpp>


using namespace LV2;


class DLatch : public Plugin<DLatch> {
public:

  DLatch(double rate)
    : Plugin<DLatch>(5) {
  }

  void run(uint32_t nframes) {
    if (*p(3) > 0 && *p(0) > 0 && *p(2) > 0){
    	*p(1) = 1;
    	*p(4) = 0;
    }
    if (*p(3) > 0 && *p(0) <= 0 && *p(2) > 0){
    	*p(1) = 0;
    	*p(4) = 1;
    }
  }

protected:
};


static int _ = DLatch::register_class("http://uli-plugins.sourceforge.net/lv2/dlatch");
