#include <lv2plugin.hpp>


using namespace LV2;


class JKFlipFlop : public Plugin<JKFlipFlop> {
public:

  JKFlipFlop(double rate)
    : Plugin<JKFlipFlop>(5) {

  }

  void run(uint32_t nframes) {
    if (*p(3) > 0 && *p(0) == 0 && *p(2) > 0 &&  *p(1) != 0){
    	*p(1) = 0;
    	*p(4) = 1;
    }
    if (*p(0) > 0 && *p(2) > 0 && *p(1) != 1){
    	*p(1) = 1;
    	*p(4) = 0;
    }
  }

};


static int _ = JKFlipFlop::register_class("http://uli-plugins.sourceforge.net/lv2/jkflipflop");
