#include <lv2plugin.hpp>


using namespace LV2;


class Nand2I : public Plugin<Nand2I> {
public:

  Nand2I(double rate)
    : Plugin<Nand2I>(3) {

  }

  void run(uint32_t nframes) {
    if (*p(0) > 0 && *p(1) > 0)
    	*p(2) = 0;
    else
    	*p(2) = 1;
  }

};


static int _ = Nand2I::register_class("http://uli-plugins.sourceforge.net/lv2/nand2i");
