#include <lv2plugin.hpp>


using namespace LV2;


class TFlipFlop : public Plugin<TFlipFlop> {
public:

  TFlipFlop(double rate)
    : Plugin<TFlipFlop>(5) {
	  m_lastclock = 0;
  }

  void run(uint32_t nframes) {
    if (*p(0) > 0 && *p(2) > 0 && m_lastclock <= 0){
    	if (*p(1) <= 0) {
    		*p(1) = 1;
    		*p(3) = 0;
    	}
    	else {
    		*p(1) = 0;
    		*p(3) = 1;
    	}
    }
    m_lastclock = *p(2);
  }

protected:
	float m_lastclock;
};


static int _ = TFlipFlop::register_class("http://uli-plugins.sourceforge.net/lv2/tflipflop");
